﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Syncfusion.JavaScript.Web;

namespace GanttTestSample
{
    public partial class GanttSample : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            // BindDataSource();
            var resource = GanttDefaultData.ResourceDataContext.GetResourceData();
            var DataSource = GanttDefaultData.GetTaskData();
            this.Gantt.DataSource = DataSource;
            this.Gantt.DataBind();
            this.Gantt.Resources = resource;
        }

        public class GanttDefaultData
        {

            public class TaskDetails
            {
                public int TaskID { get; set; }
                public string TaskName { get; set; }
                public string StartDate { get; set; }
                public string EndDate { get; set; }
                public int Duration { get; set; }
                public string Progress { get; set; }
                public List<TaskDetails> SubTasks { get; set; }
                public List<object> ResourceID { get; set; }
                public string Predecessors { get; set; }
                public bool isExpanded { get; set; }

                internal void Add(TaskDetails taskDetails)
                {
                    throw new NotImplementedException();
                }
            }

            public static List<TaskDetails> GetTaskData()
            {
                List<TaskDetails> tasks = new List<TaskDetails>();

                tasks.Add(new TaskDetails()
                {
                    TaskID = 1,
                    TaskName = "Parent 1",
                    StartDate = "01/06/2015",
                    Duration = 5,
                });

                tasks[0].SubTasks = new List<TaskDetails>();

                tasks[0].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 2,
                    TaskName = "Task 2",
                    StartDate = "01/06/2015",
                    EndDate = "01/10/2015",
                });

                tasks[0].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 3,
                    TaskName = "Task 3",
                    StartDate = "02/10/2015",
                    EndDate = "02/15/2015",
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[0].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 4,
                    TaskName = "Task 4",
                    StartDate = "03/15/2015",
                    EndDate = "03/22/2015",
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[0].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 5,
                    TaskName = "Task 5",
                    StartDate = "04/12/2015",
                    EndDate = "04/18/2015",
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[0].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 6,
                    TaskName = "Task 6",
                    StartDate = "07/27/2015",
                    EndDate = "08/04/2015",
                    Predecessors = "3FS,4FS,5FS"
                });
                tasks[0].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 7,
                    TaskName = "Task 7",
                    StartDate = "09/27/2015",
                    EndDate = "10/04/2015",
                    Predecessors = "3FS,4FS,5FS"
                });

            
                tasks.Add(new TaskDetails()
                {
                    TaskID = 8,
                    TaskName = "Parent 2",
                    StartDate = "01/06/2015",
                    Duration = 8,
                });

                tasks[1].SubTasks = new List<TaskDetails>();

                tasks[1].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 9,
                    TaskName = "Task 2",
                    StartDate = "01/06/2015",
                    EndDate = "01/10/2015",
                });

                tasks[1].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 10,
                    TaskName = "Task 3",
                    StartDate = "02/10/2015",
                    EndDate = "02/15/2015",
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[1].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 11,
                    TaskName = "Task 4",
                    StartDate = "03/15/2015",
                    EndDate = "03/20/2015",
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[1].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 12,
                    TaskName = "Task 5",
                    StartDate = "04/12/2015",
                    EndDate = "04/18/2015",
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[1].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 13,
                    TaskName = "Task 6",
                    StartDate = "07/27/2015",
                    EndDate = "08/04/2015",
                    Predecessors = "3FS,4FS,5FS"
                });
                tasks[1].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 14,
                    TaskName = "Task 7",
                    StartDate = "09/27/2015",
                    EndDate = "10/05/2015",
                    Predecessors = "3FS,4FS,5FS"
                });

              
                tasks.Add(new TaskDetails()
                {
                    TaskID = 15,
                    TaskName = "Parent 3",
                    StartDate = "01/06/2015",
                    Duration = 8,
                });

                tasks[2].SubTasks = new List<TaskDetails>();

                tasks[2].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 16,
                    TaskName = "Task 2",
                    StartDate = "01/06/2015",
                    EndDate = "01/12/2015",
                });

                tasks[2].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 17,
                    TaskName = "Task 3",
                    StartDate = "02/10/2015",
                    EndDate = "02/15/2015",
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[2].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 18,
                    TaskName = "Task 4",
                    StartDate = "03/15/2015",
                    EndDate = "03/30/2015",
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[2].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 19,
                    TaskName = "Task 5",
                    StartDate = "04/12/2015",
                    EndDate = "04/18/2015",
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[2].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 20,
                    TaskName = "Task 6",
                    StartDate = "07/27/2015",
                    EndDate = "08/04/2015",
                    Predecessors = "3FS,4FS,5FS"
                });
                tasks[2].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 21,
                    TaskName = "Task 7",
                    StartDate = "09/27/2015",
                    EndDate = "10/05/2015",
                    Predecessors = "3FS,4FS,5FS"
                });
                return tasks;

            }


            public class ResourceDataContext
            {
                public class Resources
                {
                    public int ResourceID { get; set; }
                    public string ResourceName { get; set; }
                }

                public static List<Resources> GetResourceData()
                {
                    List<Resources> resourceDetails = new List<Resources>();

                    resourceDetails.Add(new Resources() { ResourceID = 1, ResourceName = "Project Manager" });
                    resourceDetails.Add(new Resources() { ResourceID = 2, ResourceName = "Software Analyst" });
                    resourceDetails.Add(new Resources() { ResourceID = 3, ResourceName = "Developer" });
                    resourceDetails.Add(new Resources() { ResourceID = 4, ResourceName = "Testing Engineer" });

                    return resourceDetails;
                }

            }
        }

        public class DefaultData
        {
            public string StartDate { get; set; }
            public string EndDate { get; set; }
            public int Id { get; set; }
            public string Name { get; set; }
            public int Duration { get; set; }
            public string PercentDone { get; set; }
            public List<object> ResourceID { get; set; }
            public List<DefaultData> Children { get; set; }
            public string Predescessor { get; set; }
            public bool isExpaned { get; set; }
        }        
    }
}